<template>
  <span :id="id" :name="field.name+'_show'" class="component-input-span">
    <template
      v-if="field.displayType == Constant.PermissionType_HIDDEN || (field.textType && field.textType.toLowerCase() == 'hidden')"
    >
      <!-- 隐藏 TODO:注意，隐藏时不应该有hidden的field存在，有安全问题，以后要改过来：Jarod -->
      <input type="hidden" v-model="field.value" />
      <!-- <span style="width:100%;padding-left:10px;">{{field.hiddenValue}}</span> -->
      <a class="mint-cell mint-field" v-if="field.mobile && field.hiddenValue">
        <div class="mint-cell-wrapper">
          <div class="mint-cell-title">
            <span class="mint-cell-text">{{field.discript?field.discript:field.name}}</span> 
          </div> 
          <div class="mint-cell-value readOnly">
            <span>{{field.hiddenValue}}</span>
          </div> 
        </div>
      </a>
    </template>

    <template v-else-if="field.textType.toLowerCase() == 'readonly' || field.displayType == Constant.PermissionType_READONLY || field.displayType == Constant.PermissionType_DISABLED">
      <template v-if="field.readOnlyShowValOnly">
        <!-- 只读（文本模式） -->
        <a class="mint-cell mint-field" v-if="field.mobile">
          <div class="mint-cell-wrapper">
            <div class="mint-cell-title">
              <span class="mint-cell-text">
                {{field.discript?field.discript:field.name}}
                <span style="color:red" v-if="field.essential || field.instantValidate || (field.validateLibs && field.validateLibs.indexOf('checkEmpty_system') > 0)">*</span>
              </span> 
            </div> 
            <div class="mint-cell-value readOnly">
              <span style = "color: #888;">{{field.value}}</span>
            </div> 
          </div>
        </a>
      </template>
      <template v-else>
        <!-- 只读（控件模式） -->
        <div class="sug-wrap" v-if="field.mobile">
          <div class="sug-input">
            <!-- <mt-field 
              :label="field.discript?field.discript:field.name"
              :name="field.name" 
              v-model="field.value" 
              :title="field.title"
              :readonly="true" 
              :disableClear="true"
              >
            </mt-field> -->
              <a class="mint-cell mint-field" v-if="field.mobile">
                <div class="mint-cell-wrapper">
                  <div class="mint-cell-title">
                    <span class="mint-cell-text">
                      {{field.discript?field.discript:field.name}}
                      <span style="color:red" v-if="field.essential || field.instantValidate || (field.validateLibs && field.validateLibs.indexOf('checkEmpty_system') > 0)">*</span>
                    </span> 
                  </div> 
                  <div class="mint-cell-value readOnly">
                    <span style = "color: #888;">{{field.value}}</span>
                  </div> 
                </div>
              </a>
          </div>
        </div>
      </template>
    </template>

    <template v-else-if="field.displayType == Constant.PermissionType_MODIFY">
      <!-- 可编辑 -->
      <div class="sug-wrap" v-if="field.mobile && (field.layout == 'horizontal' || field.layoutType == 'horizontal')">
        <div class="sug-input" :class="{textareaCheck: isActive }">
          <!-- <mt-field 
            :label="field.discript?field.discript:field.name"
            :name="field.name" 
            v-model="field.value" 
            :placeholder="$t('please_enter')"
            title="field.title"
            @focus.native.capture="showSuggest"
            @blur.native.capture="hideSelectionBox()"
            @input="inputFunction"
          >
          </mt-field> -->
          <a class="mint-cell mint-field" :name="$t('smart_search')" title="field.title">
            <div class="mint-cell-wrapper" :class="{ textCheck: isActive }">
              <div class="mint-cell-title">
                <span class="mint-cell-text">
                  {{field.discript?field.discript:field.name}}
                  <span style="color:red" v-if="field.essential || field.instantValidate || (field.validateLibs && field.validateLibs.indexOf('checkEmpty_system') > 0)">*</span>
                </span> 
              </div> 
              <div class="mint-cell-value">
                <input 
                  :placeholder="$t('please_enter')"
                  type="text" 
                  class="mint-field-core"
                  v-model="value"
                  @focus.native.capture="showSuggest"
                  @blur.native.capture="hideSelectionBox()"
                  @input="inputFunction"
                >
                <div class="mint-field-clear" :style="{display: isFieldClear?'block':'none'}">
                  <i class="mintui mintui-field-error" @touchstart.stop.prevent="clearValue()"></i>
                </div> 
                <span class="mint-field-state is-default">
                  <i class="mintui mintui-field-default"></i>
                </span> 
                <div class="mint-field-other"></div>
              </div> 
            </div> 
          </a>
          <div class="tips" v-show="isActive">
            {{errorMessage}}
          </div>
          <div class="all-sugs" v-if="isOrHidden" @click.stop.prevent="hideSelectionBox()">
            <div class="sug-list">
              <ul>
                <li v-for="(item, index) in searchList" :key="index"  @click.stop.prevent="selectSug(item)">{{item.option}}</li>
              </ul>
            </div>
          </div>
        </div>
      </div>

      <!-- 垂直 -->
      <div class="sug-wrap textarea-cell" v-if="field.mobile && field.layout == 'vertical'">
        <div class="titleName">
          {{field.discript?field.discript:field.name}}
          <span style="color:red" v-if="field.essential || field.instantValidate || (field.validateLibs && field.validateLibs.indexOf('checkEmpty_system') > 0)">*</span>
        </div>
        <div class="sug-input" :class="{textareaCheck: isActive }">
          <a class="mint-cell mint-field" :name="$t('smart_search')" title="field.title">
            <div class="mint-cell-wrapper" :class="{ textCheck: isActive }">
              <div class="mint-cell-value">
                <input 
                  :placeholder="$t('please_enter')"
                  type="text" 
                  class="mint-field-core"
                  v-model="value"
                  @focus.native.capture="showSuggest"
                  @blur.native.capture="hideSelectionBox()"
                  @input="inputFunction"
                >
                <div class="mint-field-clear" :style="{display: isFieldClear?'block':'none'}">
                  <i class="mintui mintui-field-error" @touchstart.stop.prevent="clearValue()"></i>
                </div> 
                <span class="mint-field-state is-default">
                  <i class="mintui mintui-field-default"></i>
                </span> 
                <div class="mint-field-other"></div>
              </div> 
            </div> 
          </a>
          <div class="tips" v-show="isActive">
            {{errorMessage}}
          </div>
          <div class="all-sugs" v-if="isOrHidden" @click.stop.prevent="hideSelectionBox()">
            <div class="sug-list">
              <ul>
                <li v-for="(item, index) in searchList" :key="index"  @click.stop.prevent="selectSug(item)">{{item.option}}</li>
              </ul>
            </div>
          </div>
        </div>
      </div>
    </template>
  </span>
</template>

<script>
import Constant from "@/Constant.js"
import API from "@/api.js"
import controlHidden from "@/assets/js/controlHidden.js"
export default {
  name: "o-suggest",
  props: ["id"],
  computed: {
    field: function() {
      let formData = this.$parent.findField(this.id);
      // if(formData.dataMode == 'local') {
      //   for(let i=0; i < formData.options.length; i++){
      //     if(formData.value ===  formData.options[i].value) {
      //       this.setCurrentValue(formData.options[i].option)
      //     }
      //     let temp = formData.options[i].option;
      //     formData.options[i].option =formData.options[i].value;
      //     formData.options[i].value = temp;
      //   }
      // }else 
      if(formData.discript) {//识别控件描述最后一个字符为*时，*变红
        if(formData.discript.charAt(formData.discript.length - 1) == "*") {
          formData.discript = formData.discript.replace(/(\s|\*)+$/g, '');
          formData.essential = true;
        }
      }
     
      if(formData.value) {
        this.getQuerySearch(formData.dataMode, formData.formId, formData.docId, formData.divId, formData.value);
      }
      
      return formData;
    },
  },
  mounted(){
    this.$nextTick(()=>{
      let field = this.field;
      if(field.isHideType) {
        let id = this.id,
          formShowType = field.formShowType;
        controlHidden({id, field, formShowType})
      }
    })
  },
  data: function() {
    return { 
      Constant,
      isOrHidden:false,
      searchList:[],
      isActive:false,
      errorMessage:'',
      value:'',
      isFieldClear:false,
    };
  },
  methods: {
    clearValue() {
      this.value = '';
      this.isFieldClear = false;
    },
    setCurrentValue(value) {
      this.value = value;
    }, 
    getQuerySearch(dataMode, formId, docId, divId, value) {
      if(dataMode == 'remote') {
        let appId = this.$root.appid;
        API.intellectTip(
          appId,
          formId,
          docId,
          {
            formFieldId: divId,
            keyword: value,
            parentId: "",
          },
          {
            onSucess: res => {
              let data = res.data.data;
              if(data && data.length > 0) {
                for(let i=0; i<data.length; i++) {
                  if(value === data[i].id) {
                    this.value = data[i].name;
                  }
                }
              }
            }
          }
        );
      }else {
        this.value = value
      }
    },
    inputFunction(){
      if(this.value) {
        this.isOrHidden = true;
        let value = this.value;
        let arr = [];
        if(this.field.dataMode == 'local'){
          this.field.value = this.value;
          let options = JSON.parse(JSON.stringify(this.field.options));
          for(let i=0; i<options.length; i++){
            if(options[i].option.indexOf(value)>=0){
              arr.push(options[i]);
            }
          }
          this.searchList = arr;
        }else if(this.field.dataMode == 'remote'){
          this.field.value = this.value;
          let appId = this.$root.appid;
          let formId = this.field.formId;
          let docId = this.field.docId;
          API.intellectTip(
            appId,
            formId,
            docId,
            {
              formFieldId: this.field.divId,
              keyword: this.value,
              parentId: "",
            },
            {
              onSucess: response => {
                let options = response.data.data;
                let arr = [];
                for(let j=0; j<options.length; j++) {
                  let obj = {};
                  obj.option = options[j].name;
                  obj.value = options[j].id;
                  obj.def = options[j].def;
                  arr.push(obj);
                }
                this.searchList = arr;
              }
            }
          );
        }
      }else {
        this.isOrHidden = false;
      }
      if(!this.value) {
        this.isFieldClear = false;
      }else {
        this.isFieldClear = true;
      }
    },
    //焦点在时展示数据
    showSuggest() {
      
    },

    selectSug(item) {
      if(this.field.dataMode == 'local'){
        this.field.value = item.value;
        this.value = item.option;
      }else if(this.field.dataMode == 'remote'){
        this.field.value = item.value;
        this.value = item.option;
      }
      this.isOrHidden = false;
      if(this.field.instantValidate) {
        this.isFieldClear = false;
        let value = true;
        let formData = this.$parent.checkData(value);
        this.$api.formValidation(
          this.$root.appid, 
          formData,
          {
            onSucess: response => {
              if(response.data.errcode == 4001) {
                if(response.data.errors && response.data.errors.length > 0) {
                  let arr = response.data.errors;
                  for(let i=0; i<arr.length; i++) {
                    if(this.field.name == arr[i].field) {
                      this.isActive = true;
                      this.errorMessage = arr[i].errmsg
                      return;
                    }else {
                      this.isActive = false;
                      this.errorMessage = '';
                    }
                  }
                }
              }else if(response.data.errcode == 0) {
                this.isActive = false;
              }
            }
          }
        )
      } 
      if (this.field.refreshOnChanged){
        // this.$parent.refresh(this.id);
        let havePar = false;
        let par  = '';
        while(!havePar) {
          par = par + '.$parent';
          let url = 'this' + par + '.refresh';
          if(eval(url)) {
            let path = url + '(' + "'"+ this.id +"'" + ')';
            eval(path);
            break
          }
        }
      }
      
      // this.isOrHidden = false;
    },

    hideSelectionBox() {
      setTimeout(()=>{
        this.isOrHidden = false;
      }, 100)
      
    },

    querySearch(queryString, cb) {
      if(this.field.dataMode == 'local'){
        let field = this.$parent.findField(this.id);
        let options = field.options;
        let results = queryString
          ? options.filter(this.createFilter(queryString))
          : options;
        // 调用 callback 返回建议列表的数据
        cb(results);
        if (this.field.refreshOnChanged){//判断是否需要刷新
          this.onChange();
        }
        
      }else if(this.field.dataMode == 'remote'){
        let appId = this.$root.appid;
        let formId = this.field.formId;
        let docId = this.field.docId;
        API.intellectTip(
          appId,
          formId,
          docId,
          {
            formFieldId: this.field.divId,
            keyword: this.field.value,
            parentId: "",
          },
          {
            onSucess: response => {
              let options = response.data.data;
              for(let i=0; i < options.length; i++){
                options[i].value = options[i].name;
              }
              let results = queryString 
                ? options.filter(this.createFilter(queryString)) 
                : options;
              cb(results);
            }
          }
        );
      }
      
    },

    createFilter(queryString) {
      return options => {
        return (
          options.value.toLowerCase().indexOf(queryString.toLowerCase()) >= 0
        );
      };
    },

    onChange() {
      // this.$parent.refresh(this.id);
      let havePar = false;
      let par  = '';
      while(!havePar) {
        par = par + '.$parent';
        let url = 'this' + par + '.refresh';
        if(eval(url)) {
          let path = url + '(' + "'"+ this.id +"'" + ')';
          eval(path);
          break
        }
      }
    },
  }
};
</script>